#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire300three4xi.py">
#<abstract4xi abstract = "fires to direction three and to distance 300"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire300three4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - )
# -------------------------------------------------------------------------------------------------    
global shot2three3004xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - ) - STUBS ONLY - ALL ARE IN FILES
# -------------------------------------------------------------------------------------------------    

shot2three3004xi = {
                1:'0x11y-299z',
                2:'0x1y-299z',
                3:'0x291y-72z',
                4:'0x2y-299z',
                5:'0x5y-299z',
                6:'0x70y-291z',
                7:'0x8y-299z',
                8:'104x68y-272z',
                9:'105x275y-51z',
                10:'108x256y-111z',
                11:'110x217y-174z',
                12:'110x238y-145z',
                13:'11x27y-298z',
                14:'11x78y-289z',
                15:'120x270y-48z',
                16:'122x213y-171z',
                17:'122x251y-108z',
                18:'123x233y-142z',
                19:'12x11y-299z',
                20:'134x207y-169z',
                21:'134x264y-45z',
                22:'136x227y-139z',
                23:'136x245y-105z',
                24:'146x201y-166z',
                25:'148x257y-42z',
                26:'149x221y-137z',
                27:'149x238y-103z',
                28:'14x29y-298z',
                29:'157x195y-164z',
                30:'15x12y-299z',
                31:'15x291y-69z',
                32:'161x214y-134z',
                33:'161x249y-39z',
                34:'162x231y-100z',
                35:'168x188y-161z',
                36:'16x80y-288z',
                37:'173x206y-131z',
                38:'174x223y-97z',
                39:'175x240y-36z',
                40:'179x180y-159z',
                41:'17x251y-163z',
                42:'17x31y-297z',
                43:'184x198y-129z',
                44:'186x214y-94z',
                45:'187x231y-33z',
                46:'189x171y-156z',
                47:'18x13y-299z',
                48:'195x189y-126z',
                49:'198x205y-91z',
                50:'199x162y-154z',
                51:'199x221y-30z',
                52:'1x14y-299z',
                53:'206x179y-123z',
                54:'209x152y-151z',
                55:'209x195y-88z',
                56:'20x33y-297z',
                57:'211x211y-27z',
                58:'216x169y-120z',
                59:'21x82y-287z',
                60:'220x184y-86z',
                61:'222x200y-24z',
                62:'225x158y-118z',
                63:'230x173y-83z',
                64:'232x188y-21z',
                65:'239x161y-80z',
                66:'23x270y-128z',
                67:'23x34y-297z',
                68:'242x175y-18z',
                69:'25x0y-298z',
                70:'26x83y-286z',
                71:'27x35y-296z',
                72:'2x3y-299z',
                73:'30x251y-160z',
                74:'30x290y-66z',
                75:'31x36y-296z',
                76:'32x85y-285z',
                77:'34x36y-295z',
                78:'37x269y-125z',
                79:'37x85y-284z',
                80:'39x36y-295z',
                81:'3x17y-299z',
                82:'3x73y-290z',
                83:'43x36y-294z',
                84:'43x86y-284z',
                85:'44x251y-158z',
                86:'45x289y-63z',
                87:'47x36y-294z',
                88:'49x86y-283z',
                89:'4x20y-299z',
                90:'4x250y-165z',
                91:'4x6y-299z',
                92:'51x35y-293z',
                93:'52x268y-122z',
                94:'55x86y-282z',
                95:'57x250y-155z',
                96:'61x287y-60z',
                97:'61x85y-280z',
                98:'66x266y-119z',
                99:'67x84y-279z',
                100:'6x22y-299z',
                101:'71x248y-152z',
                102:'73x227y-181z',
                103:'73x82y-278z',
                104:'76x284y-57z',
                105:'79x80y-277z',
                106:'7x76y-290z',
                107:'7x7y-299z',
                108:'80x264y-117z',
                109:'81x305y-245z',
                110:'84x245y-150z',
                111:'85x224y-179z',
                112:'85x78y-276z',
                113:'91x280y-54z',
                114:'92x75y-275z',
                115:'94x260y-114z',
                116:'97x242y-147z',
                117:'98x221y-176z',
                118:'98x72y-274z',
                119:'9x25y-298z',
                120:'9x269y-130z',
                121:'9x9y-299z'}
                
 
# -----------------------------------------------------------------------------------------------------------
#<function4xi function = "fire300three4xi" usage = "target function for chargethree4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -----------------------------------------------------------------------------------------------------------
def fire300three4xi(queue2three, consumer_channel2three, publisher_channel2three):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE300THREE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE300THREE4XI -  QUEUE2THREE: ", queue2three)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE300THREE4XI -  CONSUMER_CHANNEL2THREE: ", consumer_channel2three)
        #  
              
        print("\n (STEP 1A4/33) OF FIRE300THREE4XI -  PUBLISHER_CHANNEL2THREE: ", publisher_channel2three)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE300THREE4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2three.put(shot2three3004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE300THREE4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE300THREE4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE300THREE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4three = "<ack2put4xi>queue2three8shot2three3004xi</ack2put4xi>"
        else:
            message2send4three = "<nack2put4xi>queue2three8shot2three3004xi</nack2put4xi>" 
            
        publisher_channel2three.send(message2send4three)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE300THREE4XI -  SENT MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE300THREE4XI *** FAILED TO SEND MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE300THREE4XI - RETURNING QUEUE OBJECT QUEUE2THREE: ", queue2three, " - TIME: ", time4xi())  
        # 
            
    return queue2three    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire300three4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                               
                